## ats-lang-anairiats 0.2.5

=== Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Potential of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi.
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
##
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
##
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
## Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
## 02110-1301, USA.
##

######

##
## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Author: Likai Liu (liulk AT cs DOT bu DOT edu)
## Author: Yuri D'Elia (wavexx AT thregr DOT org)
##

.SUFFIXES:
all:: Makefile

######

# integration with autoconf.

SRC_CONFIG_FILES := config.mk.in config.h.in
BUILT_CONFIG_FILES := $(SRC_CONFIG_FILES:%.in=%)

Makefile: config.mk

config.status: configure
	./configure
	touch $@

$(BUILT_CONFIG_FILES): %: config.status $(filter-out %,$(SRC_CONFIG_FILES))
	./config.status
	touch $(BUILT_CONFIG_FILES)

config.h.in: configure.ac
	autoheader $<
	touch $@

configure: configure.ac $(SRC_CONFIG_FILES)
	aclocal
	automake --add-missing --foreign || true
	autoconf
	touch $(BUILT_CONFIG_FILES)

-include config.mk

######

DESTDIR :=

export ATSHOME
export ATSHOMERELOC
export ATSHOMEQ

######

#
# HX-2011-06-01:
# This part is by Georg Bauhaus (bauhaus AT arcor DOT de):
# It addresses the issue that the [-D] option is not available
# for $(INSTALL) on MacOSX.
#
.PHONY: install_dirs

install_dirs:: config.h
#
# make all subdirectories needed by install.
#
	cd $(abs_top_srcdir)
	[ -d $(DESTDIR)/$(bindir) ] || $(MKDIR_P) $(DESTDIR)/$(bindir)
	$(MKDIR_P) $(DESTDIR)$(ATSNEWHOME)/bin
	find ccomp contrib doc libats libc prelude -type d \
	  -exec $(MKDIR_P) $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	  -print

install_files:: install_dirs
#
# recursively install all files in the list except .svn control files.
#
	for d in ccomp/runtime contrib doc libats libc prelude; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -d $(DESTDIR)$(ATSNEWHOME)/"$$d" && \
	  find "$$d" -name .svn -prune -o -type f \
            -exec $(INSTALL) -m 644 \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print && \
	  find "$$d" -name .svn -prune -o -type l \
            -exec cp -d \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print; \
	done
#
# install specific files in the list as regular files.
#
	for f in \
	    COPYING INSTALL *.txt ccomp/lib/*.a ccomp/lib64/*.a config.h; \
	do \
	  [ -f "$$f" ] || continue; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 644 "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done
#
# install specific files in the list as executables.
#
	for f in bin/*; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done
#
# install multiple copies of wrapper script, for each binary.
#
	for f in bin/*; do \
	  b=`basename "$$f"`; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 ats_env.sh $(DESTDIR)$(bindir)/"$$b" && \
	  echo install ats_env.sh to $(bindir)/"$$b"; \
	done

install:: install_files

######

all:: \
  atsopt1 \
  bin/atscc \
  bin/atslib \
  libfiles libfiles_mt \
  bin/atspack \
  bin/atslex \
  ccomp/runtime/GCATS/gc.o \
  ccomp/runtime/GCATS/gc_mt.o \
  atsopt1_gc \
  contrib
	@echo "ATS/Anairiats has been built up successfully!"
	@echo "The value of ATSHOME for this build is \"$(ATSHOME)\"."
	@echo "The value of ATSHOMERELOC for this build is \"$(ATSHOMERELOC)\"."

###### w/o GC ######

atsopt1::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt
	cp bootstrap1/atsopt $(ATSHOMEQ)/bin/atsopt

###### with GC ######

atsopt1_gc::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt_gc
	cp bootstrap1/atsopt_gc $(ATSHOMEQ)/bin/atsopt

###### contrib libraries ######

contrib::
ifeq (1,1)
	$(MAKE) -C contrib/parcomb all
endif
ifeq ($(HAVE_LIBGLIB20),1)
	$(MAKE) -C contrib/glib all
endif
ifeq ($(HAVE_LIBGTK20),1)
	$(MAKE) -C contrib/cairo all
	$(MAKE) -C contrib/pango all
	$(MAKE) -C contrib/GTK all
endif
ifeq ($(HAVE_LIBSDL10),1)
	$(MAKE) -C contrib/SDL all
endif

###### some toplevel commands ######

bin/atscc bin/atslib:
	$(MAKE) -C utils/scripts atscc
	$(CPF) utils/scripts/atscc $(ATSHOMEQ)/bin
	$(MAKE) -C utils/scripts atslib
	$(CPF) utils/scripts/atslib $(ATSHOMEQ)/bin
	$(MAKE) -C utils/scripts clean

bin/atspack:
	$(MAKE) -C utils/scripts atspack
	cp utils/scripts/atspack $(ATSHOMEQ)/bin

###### library ######

ATS_PROOFCHECK=
#
# ATS_PROOFCHECK=-D_ATS_PROOFCHECK # it should be turned on from time to time
#
# [CC -E] for preprocessing
#

ATSLIB=$(ATSHOMEQ)/bin/atslib

.libfiles_local: .libfiles ; $(CC) -E -P -x c -o $@ $<
libfiles: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_smlbas

lib32files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_smlbas

lib64files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_smlbas

.libfiles_mt_local: .libfiles_mt ; $(CC) -E -P -x c -o $@ $<
libfiles_mt: .libfiles_mt_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_ATS_MULTITHREAD -O2 --libats_mt

###### a lexer for ATS ######

bin/atslex:
	cd utils/atslex; $(MAKE) atslex; cp atslex $(ATSHOMEQ)/bin
	cd utils/atslex; $(MAKE) clean

###### GC runtime ######

ccomp/runtime/GCATS/gc.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc.o; $(MAKE) clean

ccomp/runtime/GCATS/gc_mt.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc_mt.o; $(MAKE) clean

######

CPF=cp -f
RMF=rm -f

######

clean::
	$(RMF) bootstrap1/*.o
	$(MAKE) -C utils/scripts clean
	$(MAKE) -C utils/atslex clean
	$(MAKE) -C ccomp/runtime/GCATS clean

cleanall::
	$(RMF) bootstrap1/*.o
	$(RMF) $(BUILT_CONFIG_FILES)
	$(RMF) .libfiles_local
	$(RMF) .libfiles_mt_local
	$(RMF) bin/atsopt bin/atscc bin/atslib bin/atslex bin/atspack
	$(RMF) ccomp/lib/libats.a
	$(RMF) ccomp/lib/libats_mt.a
	$(RMF) ccomp/lib/libats_lex.a
	$(RMF) ccomp/lib/libats_smlbas.a
	$(RMF) ccomp/lib/output/*
	$(RMF) ccomp/lib64/libats.a
	$(RMF) ccomp/lib64/libats_mt.a
	$(RMF) ccomp/lib64/libats_lex.a
	$(RMF) ccomp/lib64/libats_smlbas.a
	$(RMF) ccomp/lib64/output/*
	$(RMF) contrib/glib/atsctrb_glib.o
	$(RMF) contrib/cairo/atsctrb_cairo.o
	$(RMF) contrib/pango/atsctrb_pango.o
	$(RMF) contrib/X11/atsctrb_X11.o
	$(RMF) contrib/GTK/atsctrb_GTK.o
	$(RMF) contrib/GL/atsctrb_GL.o
	$(RMF) contrib/SDL/atsctrb_SDL.o

cleanall:: ; $(MAKE) -C utils/atslex cleanall
cleanall:: ; $(MAKE) -C utils/scripts cleanall
cleanall:: ; $(MAKE) -C ccomp/runtime/GCATS cleanall

distclean:: cleanall
distclean:: ; find . -name .svn -prune -o -name \*~ -exec rm \{} \;

######
#
# end of [Makefile_dist]
#
######

=== contrib/GL/Makefile ===
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: December, 2009
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

ATSCC=$(ATSUSRQ)/bin/atscc

######

all: atsctrb_GL.o clean

######

atsctrb_GL.o: \
          gl_sats.o glu_sats.o \
          glut_sats.o glut_dats.o
	ld -r -o $@ \
          gl_sats.o glu_sats.o glut_sats.o glut_dats.o

######

gl_sats.o: SATS/gl.sats
	$(ATSCC) -o $@ -c SATS/gl.sats

glu_sats.o: SATS/glu.sats
	$(ATSCC) -o $@ -c SATS/glu.sats

glut_sats.o: SATS/glut.sats
	$(ATSCC) -o $@ -c SATS/glut.sats
glut_dats.o: DATS/glut.dats
	$(ATSCC) -o $@ -c DATS/glut.dats

######

clean::
	rm -f gl_sats.c gl_sats.o
	rm -f glu_sats.c glu_sats.o
	rm -f glut_sats.c glut_sats.o
	rm -f glut_dats.c glut_dats.o

cleanall: clean
	rm -f atsctrb_GL.o

###### end of [Makefile] ######

=== contrib/GTK/Makefile ===
#
# API for GTK in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: May, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc -Wall
GTKCFLAGS = `pkg-config gtk+-2.0 --cflags`

######

all:: atsctrb_GTK.o
all:: clean

######

atsctrb_GTK.o: GTK_dats.o
	ld -r -o $@ GTK_dats.o

######

GTK_dats.o: DATS/gtk.dats
	$(ATSCC) $(GTKCFLAGS) -o $@ -c DATS/gtk.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_GTK.o

###### end of [Makefile] ######

=== contrib/glib/Makefile ===
#
# API for glib in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: February, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc -Wall
GLIBCFLAGS = `pkg-config glib-2.0 --cflags`

######

GCC=gcc

######

all:: glibconfig
all:: atsctrb_glib.o
all:: clean

######

glibconfig:: HATS/glibconfig
	$(GCC) $(GLIBCFLAGS) -E -P -o HATS/glibconfig.hats -x c HATS/glibconfig

######

atsctrb_glib.o: \
  glib_sats.o glib_dats.o
	ld -r -o $@ \
  glib_sats.o glib_dats.o

######

glib_sats.o: SATS/glib.sats
	$(ATSCC) $(GLIBCFLAGS) -o $@ -c SATS/glib.sats

glib_dats.o: DATS/glib.dats
	$(ATSCC) $(GLIBCFLAGS) -o $@ -c DATS/glib.dats

######

clean::
	rm -f glib_sats.c glib_sats.o
	rm -f glib_dats.c glib_dats.o

cleanall: clean
	rm -f atsctrb_glib.o

###### end of [Makefile] ######

=== doc/EXAMPLE/AUP/Makefile ===
######
#
# Makefile file for some examples translated from the book:
# Advanced UNIX Programming (2nd edition) by Marc Rochkind
#
######

#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Start Time: Summer, 2009
# Second Time: Fall, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all: checkall

######

checkall: compall cleanall

######

compall:: testlock
testlock: AUP_2_4_3.dats; $(ATSCC) -o $@ $^

compall:: backward
backward: AUP_2_13.dats
	$(ATSCC) -o $@ $^ && ./$@ "AUP_2_13.dats"

compall:: backward2
backward2: AUP_2_14.dats
	$(ATSCC) -o $@ $^ && ./$@ "AUP_2_14.dats"

#######

compall:: pathnames
pathnames: AUP_3_4.dats; $(ATSCC) -o $@ $^ && ./$@

compall:: longls
longls: AUP_3_5.dats; $(ATSCC) -o $@ $^ && ./$@

compall:: getcwdx
getcwdx: AUP_3_6_4.dats; $(ATSCC) -o $@ $^ && ./getcwdx

#######

compall:: test421
test421: AUP_4_2_1.dats; $(ATSCC) -o $@ $^

compall:: test4221
test4221: AUP_4_2_2_1.dats; $(ATSCC) -o $@ $^

compall:: test4222
test4222: AUP_4_2_2_2.dats; $(ATSCC) -o $@ $^

compall:: test423
test423: AUP_4_2_3.dats; $(ATSCC) -o $@ $^

compall:: test435
test435: AUP_4_3_5.dats; $(ATSCC) -o $@ $^

compall:: test47
test47: AUP_4_7.dats; $(ATSCC) -o $@ $^ && ./test47

compall:: test48
test48: AUP_4_8.dats; $(ATSCC) -o $@ $^ -lcurses

#######

compall:: test52
test52: AUP_5_2.dats; $(ATSCC) -o $@ $^ && ./test52

#######

getargs.o: utils/getargs.c
	$(ATSCC) -Wall -c -o $@ $<

compall:: aupsh1
aupsh1: AUP_5_4.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

compall:: aupsh2
aupsh2: AUP_5_6.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

compall:: aupsh3
aupsh3: AUP_5_10.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

#######

compall:: test511
test511: AUP_5_11.dats
	$(ATSCC) -Wall -o $@ AUP_5_11.dats \
     && ./test511

#######

compall:: aupnice
aupnice: AUP_5_15.dats
	$(ATSCC) -Wall -o $@ $<

#######

compall:: test5173
test5173: AUP_5_17_3.dats
	$(ATSCC) -D_ATS_MULTITHREAD -Wall -o $@ AUP_5_17_3.dats -lpthread \
     && ./test5173

#######

errinfo.o: utils/errinfo.sats utils/errinfo.dats
	$(ATSCC) -IATS utils -I utils -Wall -c -o $@ utils/errinfo.dats

compall:: test631
test631: AUP_6_3_1.dats errinfo.o
	$(ATSCC) -I utils -Wall -o $@ $< errinfo.o && ./test631

compall:: test65
test65: AUP_6_5.dats errinfo.o
	$(ATSCC) -I utils -Wall -o $@ $< errinfo.o && ./test65

#######

compall:: test811
test811: AUP_8_1_1.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test811

compall:: test813
test813: AUP_8_1_3.dats; $(ATSCC) -I utils -Wall -o $@ $<

compall:: test814
test814: AUP_8_1_4.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test814

compall:: test823
test823: AUP_8_2_3.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test823

compall:: test826
test826: AUP_8_2_6.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test826

compall:: test83
test83: AUP_8_3.dats; $(ATSCC) -D_XOPEN_SOURCE -Wall -o $@ $< && ./test83

compall:: test8811
test8811: AUP_8_8_1_1.dats; $(ATSCC) -Wall -o $@ $< && ./test8811

compall:: test8812
test8812: AUP_8_8_1_2.dats; $(ATSCC) -Wall -o $@ $< && ./test8812

#######

compall:: test911
test911: AUP_9_1_1.dats; $(ATSCC) -Wall -o $@ $<

compall:: test917
test917: AUP_9_1_7.dats; $(ATSCC) -Wall -o $@ $<

compall:: test923
test923: AUP_9_2_3.dats; $(ATSCC) -Wall -o $@ $< && ./test923

compall:: test971
test971: AUP_9_7_1.dats; $(ATSCC) -Wall -o $@ $<

compall:: test972
test972: AUP_9_7_2.dats; $(ATSCC) -Wall -o $@ $< && ./test972

compall:: test974
test974: AUP_9_7_4.dats; $(ATSCC) -Wall -o $@ $<

#compall:: test975 # it needs [clock_gettime] and [clock_getres]
test975: AUP_9_7_5.dats; $(ATSCC) -Wall -o $@ $< && ./test975

#######

xref:: ; $(ATSOPT) --posmark_xref=XREF -d \
  $(ATSHOME)/utils/xref/ats_prelude_xref.dats > /dev/null
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_4_3.dats > AUP_2_4_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_13.dats > AUP_2_13_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_14.dats > AUP_2_14_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_4.dats > AUP_3_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_5.dats > AUP_3_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_6_4.dats > AUP_3_6_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_1.dats > AUP_4_2_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_2_1.dats > AUP_4_2_2_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_2_2.dats > AUP_4_2_2_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_3.dats > AUP_4_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_3_5.dats > AUP_4_3_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_7.dats > AUP_4_7_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_8.dats > AUP_4_8_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_2.dats > AUP_5_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_4.dats > AUP_5_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_6.dats > AUP_5_6_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_10.dats > AUP_5_10_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_11.dats > AUP_5_11_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_15.dats > AUP_5_15_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_17_3.dats > AUP_5_17_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_6_3_1.dats > AUP_6_3_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_6_5.dats > AUP_6_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_1.dats > AUP_8_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_3.dats > AUP_8_1_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_4.dats > AUP_8_1_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_2_3.dats > AUP_8_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_2_6.dats > AUP_8_2_6_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_3.dats > AUP_8_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_8_1_1.dats > AUP_8_8_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_1_1.dats > AUP_9_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_1_7.dats > AUP_9_1_7_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_2_3.dats > AUP_9_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_1.dats > AUP_9_7_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_2.dats > AUP_9_7_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_4.dats > AUP_9_7_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_5.dats > AUP_9_7_5_dats.html

######

RMF = rm -f

#######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o
	$(RMF) MySocket
	$(RMF) errinfo.o
	$(RMF) getargs.o

cleanall:: clean
	$(RMF) ./*_?ats.html
	$(RMF) ./XREF/*.html
cleanall::
	$(RMF) testlock
	$(RMF) backward
	$(RMF) backward2
	$(RMF) pathnames
	$(RMF) longls
	$(RMF) getcwdx
cleanall::
	$(RMF) test421
	$(RMF) test4221
	$(RMF) test4222
	$(RMF) test423
	$(RMF) test435
	$(RMF) test47
	$(RMF) test48
cleanall::
	$(RMF) test52
	$(RMF) aupsh1
	$(RMF) aupsh2
	$(RMF) aupsh3
	$(RMF) test511
	$(RMF) aupnice
	$(RMF) test5173
cleanall::
	$(RMF) test631
	$(RMF) test65
cleanall::
	$(RMF) test811
	$(RMF) test813
	$(RMF) test814
	$(RMF) test823
	$(RMF) test826
	$(RMF) test83
	$(RMF) test8811
	$(RMF) test8812
cleanall::
	$(RMF) test911
	$(RMF) test917
	$(RMF) test923
	$(RMF) test971
	$(RMF) test972
	$(RMF) test974
	$(RMF) test975

###### end of [Makefile] ######

=== doc/EXAMPLE/GTK/Makefile ===
#
#
# Some Examples in ATS involving GTK+ programming
#
#

######

ATSUSRQ="$(ATSHOME)"
ATSLIBQ="$(ATSHOME)"
ifeq ("$(ATSHOME)","")
ATSUSRQ="/usr"
ATSLIBQ="/usr/lib/ats-anairiats-0.2.3"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

GTKFLAGS=`pkg-config gtk+-2.0 --cflags --libs`

######

.PHONY: all
all: checkall

######

checkall: compall cleanall

######

#
# Please do the following
#   cd $ATSHOME/contrib/GTK; make atsctrb_GTK.o
# if "atsctrb_GTK.o" is not available
#
LIBATSGTK=$(ATSLIBQ)/contrib/GTK/atsctrb_GTK.o
compall:: GameOf24
GameOf24: GameOf24.dats
	$(ATSCC) -D_ATS_GCATS -o $@ GameOf24.dats $(LIBATSGTK) $(GTKFLAGS) -lm

######

compall:: gtkcairoclock
gtkcairoclock: gtkcairoclock.dats
	$(ATSCC) -Wl,-rpath,$(ATSLIBQ)/ccomp/lib -o $@ gtkcairoclock.dats $(GTKFLAGS) -lm

######

compall:: gtkcairopascal
gtkcairopascal: gtkcairopascal.dats
	$(ATSCC) -D_ATS_GCATS -o $@ gtkcairopascal.dats $(GTKFLAGS) -lm

######

ATSCTRB=$(ATSLIBQ)/contrib/cairo/atsctrb_cairo.o
compall:: gtkcairodisc
gtkcairodisc: gtkcairodisc.dats
	$(ATSCC) -D_ATS_GCATS $(ATSCTRB) -o $@ gtkcairodisc.dats $(GTKFLAGS) -lm

######

ATSCTRB=$(ATSLIBQ)/contrib/cairo/atsctrb_cairo.o
compall:: bsearch_demo
bsearch_demo: bsearch_demo.dats
	$(ATSCC) -D_ATS_GCATS $(ATSCTRB) -o $@ bsearch_demo.dats $(GTKFLAGS) -lm

######

html:: ; $(ATSOPT) --posmark_html -d GameOf24.dats > GameOf24_dats.html
html:: ; $(ATSOPT) --posmark_html -d gtkcairoclock.dats > gtkcairoclock_dats.html
html:: ; $(ATSOPT) --posmark_html -d gtkcairopascal.dats > gtkcairopascal_dats.html
html:: ; $(ATSOPT) --posmark_html -d gtkcairopascal.dats > gtkcairopascal_dats.html
html:: ; $(ATSOPT) --posmark_html -d bsearch_demo.dats > bsearch_demo_dats.html

######

xref:: ; $(ATSOPT) --posmark_xref=XREF -d \
  $(ATSHOME)/utils/xref/ats_prelude_xref.dats > /dev/null
xref:: ; $(ATSOPT) --posmark_xref=XREF -d GameOf24.dats > GameOf24_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d gtkcairoclock.dats > gtkcairoclock_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d gtkcairopascal.dats > gtkcairopascal_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d gtkcairopascal.dats > gtkcairopascal_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d bsearch_demo.dats > bsearch_demo_dats.html

######

RMF=rm -f

######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c

cleanall:: clean
	$(RMF) ./XREF/*
	$(RMF) ./*_?ats.html
	$(RMF) GameOf24
	$(RMF) gtkcairoclock
	$(RMF) gtkcairopascal
	$(RMF) gtkcairodisc
	$(RMF) bsearch_demo

###### end of [Makefile] ######

=== doc/EXAMPLE/INTRO/Makefile ===
#
#
# Some introductory examples written in ATS
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean
cleanall:: ; $(RMF) ./XREF/*
cleanall:: ; $(RMF) *_?ats.html

######

checkall:: HelloWorld
HelloWorld: HelloWorld.dats
	$(ATSCC) -o HelloWorld HelloWorld.dats && ./HelloWorld

checkall:: f91
cleanall:: ; $(RMF) f91
f91: f91.dats
	$(ATSCC) -o f91 f91.dats && ./f91 0

checkall:: fact1
cleanall:: ; $(RMF) fact1
fact1: fact1.dats
	$(ATSCC) -o fact1 fact1.dats && ./fact1 10

checkall:: fact2
cleanall:: ; $(RMF) fact2
fact2: fact2.dats
	$(ATSCC) -o fact2 fact2.dats && ./fact2 10

checkall:: fact3
cleanall:: ; $(RMF) fact3
fact3: fact3.dats
	$(ATSCC) -D_ATS_PROOFCHECK -o fact3 fact3.dats -lats -lgmp && ./fact3 100

checkall:: fact4
cleanall:: ; $(RMF) fact4
fact4: fact4.dats
	$(ATSCC) -D_ATS_PROOFCHECK -o fact4 fact4.dats -lats -lgmp && ./fact4 10

checkall:: fact_in_c
cleanall:: ; $(RMF) fact_in_c
fact_in_c: fact_in_c.dats
	$(ATSCC) -o fact_in_c fact_in_c.dats && ./fact_in_c 10

checkall:: fibs
cleanall:: ; $(RMF) fibs
fibs: fibs.dats
	$(ATSCC) -o fibs fibs.dats -lats -lgmp && ./fibs 20

checkall:: revarr
cleanall:: ; $(RMF) revarr
revarr: revarr.dats
	$(ATSCC) -o revarr revarr.dats && ./revarr

checkall:: revstr
cleanall:: ; $(RMF) revstr
revstr: revstr.dats
	$(ATSCC) -o revstr revstr.dats && ./revstr "abcdefghijklmnopqrstuvwxyz"

checkall:: tally
cleanall:: ; $(RMF) tally
tally: tally.dats
	$(ATSCC) -o tally tally.dats -lats && ./tally

######

html:: ; $(ATSOPT) --posmark_html -d HelloWorld.dats > HelloWorld_dats.html
html:: ; $(ATSOPT) --posmark_html -d f91.dats > f91_dats.html
html:: ; $(ATSOPT) --posmark_html -d fact1.dats > fact1_dats.html
html:: ; $(ATSOPT) --posmark_html -d fact2.dats > fact2_dats.html
html:: ; $(ATSOPT) --posmark_html -d fact3.dats > fact3_dats.html
html:: html_fact4
html_fact4: ; $(ATSOPT) --posmark_html -d fact4.dats > fact4_dats.html
html:: ; $(ATSOPT) --posmark_html -d fact_in_c.dats > fact_in_c_dats.html
html:: ; $(ATSOPT) --posmark_html -d fibs.dats > fibs_dats.html
html:: ; $(ATSOPT) --posmark_html -d revarr.dats > revarr_dats.html
html:: ; $(ATSOPT) --posmark_html -d revstr.dats > revstr_dats.html
html:: ; $(ATSOPT) --posmark_html -d tally.dats > tally_dats.html

######

xref:: ; $(ATSOPT) --posmark_xref=XREF -d \
  $(ATSHOME)/utils/xref/ats_prelude_xref.dats > /dev/null
xref:: ; $(ATSOPT) --posmark_xref=XREF -d HelloWorld.dats > HelloWorld_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d f91.dats > f91_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d fact1.dats > fact1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d fact2.dats > fact2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d fact3.dats > fact3_dats.html
xref:: xref_fact4
xref_fact4: ; $(ATSOPT) --posmark_xref=XREF -d fact4.dats > fact4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d fact_in_c.dats > fact_in_c_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d fibs.dats > fibs_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d revarr.dats > revarr_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d revstr.dats > revstr_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d tally.dats > tally_dats.html

######

RMF = rm -f

######

clean:
	$(RMF) *~
	$(RMF) ./INTRO/*
	$(RMF) *_dats.c *_sats.c

###### end of [Makefile] ######

=== doc/EXAMPLE/OpenGL/Makefile ===
#
#
# A simple Makefile for some programs involving OpenGL
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSCTRB=$(ATSUSRQ)/contrib/GL/atsctrb_GL.o

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: glHello
cleanall:: ; $(RMF) glHello
glHello: glHello.dats
	$(ATSCC) -o glHello glHello.dats $(ATSCTRB) -lGL -lglut

checkall:: glDoubleBuffer
cleanall:: ; $(RMF) glDoubleBuffer
glDoubleBuffer: glDoubleBuffer.dats
	$(ATSCC) -o glDoubleBuffer glDoubleBuffer.dats $(ATSCTRB) -lGL -lglut

checkall:: glIcosahedron
cleanall:: ; $(RMF) glIcosahedron
glIcosahedron: glIcosahedron.dats
	$(ATSCC) -D_ATS_GCATS -o glIcosahedron glIcosahedron.dats $(ATSCTRB) -lGL -lGLU -lglut -lm

checkall:: glClipping
cleanall:: ; $(RMF) glClipping
glClipping: glClipping.dats
	$(ATSCC) -o glClipping glClipping.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glCubeView
cleanall:: ; $(RMF) glCubeView
glCubeView: glCubeView.dats
	$(ATSCC) -o glCubeView glCubeView.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glPlanet
cleanall:: ; $(RMF) glPlanet
glPlanet: glPlanet.dats
	$(ATSCC) -o glPlanet glPlanet.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glColoredTriangle
cleanall:: ; $(RMF) glColoredTriangle
glColoredTriangle: glColoredTriangle.dats
	$(ATSCC) -o glColoredTriangle glColoredTriangle.dats $(ATSCTRB) -lGL -lGLU -lglut -lm

checkall:: glLitSphere
cleanall:: ; $(RMF) glLitSphere
glLitSphere: glLitSphere.dats
	$(ATSCC) -o glLitSphere glLitSphere.dats $(ATSCTRB) -lGL -lglut

checkall:: glLightMove1
cleanall:: ; $(RMF) glLightMove1
glLightMove1: glLightMove1.dats
	$(ATSCC) -o glLightMove1 glLightMove1.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glLightMove2
cleanall:: ; $(RMF) glLightMove2
glLightMove2: glLightMove2.dats
	$(ATSCC) -o glLightMove2 glLightMove2.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glBlending1
cleanall:: ; $(RMF) glBlending1
glBlending1: glBlending1.dats
	$(ATSCC) -o glBlending1 glBlending1.dats $(ATSCTRB) -lGL -lGLU -lglut

checkall:: glBlending2
cleanall:: ; $(RMF) glBlending2
glBlending2: glBlending2.dats
	$(ATSCC) -o glBlending2 glBlending2.dats $(ATSCTRB) -lGL -lglut

checkall:: glDisplayList1
cleanall:: ; $(RMF) glDisplayList1
glDisplayList1: glDisplayList1.dats
	$(ATSCC) -o glDisplayList1 glDisplayList1.dats $(ATSCTRB) -lGL -lGLU -lglut -lm

######

#
# A little bit animation for fun
#
checkall:: glFaces
cleanall:: ; $(RMF) glFaces
glFaces: glFaces.dats
	$(ATSCC) -o glFaces glFaces.dats $(ATSCTRB) -lGL -lglut -lm

######

#
# A simple game of Tetris implemented in ATS
#
checkall:: glTetrix
cleanall:: ; $(RMF) glTetrix
glTetrix: glTetrix.dats
	$(ATSCC) -O2 -o glTetrix glTetrix.dats $(ATSCTRB) -lGL -lglut -lm

######

RMF = rm -f

######

clean:
	$(RMF) *~
	$(RMF) *_?ats.c
	$(RMF) *_?ats.o

###### end of [Makefile] ######

=== doc/EXAMPLE/TEST/Makefile ===
#
#
# (kind of) unit testing for ATS library code
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: prelude_array
prelude_array: prelude_array.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array
cleanall:: ; $(RMF) prelude_array

checkall:: prelude_array0
prelude_array0: prelude_array0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array0
cleanall:: ; $(RMF) prelude_array0

checkall:: prelude_bool
prelude_bool: prelude_bool.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_bool
cleanall:: ; $(RMF) prelude_bool

checkall:: prelude_char
prelude_char: prelude_char.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_char
cleanall:: ; $(RMF) prelude_char

checkall:: prelude_float
prelude_float: prelude_float.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_float
cleanall:: ; $(RMF) prelude_float

checkall:: prelude_lazy_vt
prelude_lazy_vt: prelude_lazy_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_lazy_vt
cleanall:: ; $(RMF) prelude_lazy_vt

checkall:: prelude_list
prelude_list: prelude_list.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list
cleanall:: ; $(RMF) prelude_list

checkall:: prelude_list_vt
prelude_list_vt: prelude_list_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list_vt
cleanall:: ; $(RMF) prelude_list_vt

checkall:: prelude_matrix
prelude_matrix: prelude_matrix.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix
cleanall:: ; $(RMF) prelude_matrix

checkall:: prelude_matrix0
prelude_matrix0: prelude_matrix0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix0
cleanall:: ; $(RMF) prelude_matrix0

checkall:: prelude_string
prelude_string: prelude_string.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_string
cleanall:: ; $(RMF) prelude_string

######

checkall:: libc_math
libc_math: libc_math.dats
	$(ATSCC) -O2 -o $@ $< -lm && ./libc_math
cleanall:: ; $(RMF) libc_math

checkall:: libc_complex
libc_complex: libc_complex.dats
	$(ATSCC) -O2 -o $@ $< -lm && ./libc_complex
cleanall:: ; $(RMF) libc_complex

######

checkall:: libc_dirent
libc_dirent: libc_dirent.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_dirent "."
cleanall:: ; $(RMF) libc_dirent

checkall:: libc_dlfcn
libc_dlfcn: libc_dlfcn.dats
	$(ATSCC) -rdynamic -O2 -o $@ $< -ldl && ./libc_dlfcn "."
cleanall:: ; $(RMF) libc_dlfcn

######

checkall:: libc_gmp
libc_gmp: libc_gmp.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< -lats -lgmp && ./libc_gmp
cleanall:: ; $(RMF) libc_gmp

######

checkall:: libc_printf
libc_printf: libc_printf.dats
	$(ATSCC) -o $@ $< && ./libc_printf
cleanall:: ; $(RMF) libc_printf

######

checkall:: libc_pwd
libc_pwd: libc_pwd.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_pwd
cleanall:: ; $(RMF) libc_pwd

######

checkall:: libc_random
libc_random: libc_random.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_random
cleanall:: ; $(RMF) libc_random

######

checkall:: libc_sched
libc_sched: libc_sched.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< && ./libc_sched
cleanall:: ; $(RMF) libc_sched

######

checkall:: libc_stdio
libc_stdio: libc_stdio.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdio
cleanall:: ; $(RMF) libc_stdio

checkall:: libc_stdlib
libc_stdlib: libc_stdlib.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdlib
cleanall:: ; $(RMF) libc_stdlib

######

checkall:: libc_time
libc_time: libc_time.dats
	$(ATSCC) -D_XOPEN_SOURCE -O2 -o $@ $< && ./libc_time
cleanall:: ; $(RMF) libc_time

######

checkall:: libc_unistd
libc_unistd: libc_unistd.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_unistd
cleanall:: ; $(RMF) libc_unistd

######


checkall:: libc_sys_utsname
libc_sys_utsname: libc_sys_utsname.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_sys_utsname
cleanall:: ; $(RMF) libc_sys_utsname

######


checkall:: libats_funarray_braun
libats_funarray_braun: libats_funarray_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< \
     && ./libats_funarray_braun 0 1 2 3 4 5 6 7 8 9
cleanall:: ; $(RMF) libats_funarray_braun

######

checkall:: libats_fundeque_fingertree
libats_fundeque_fingertree: libats_fundeque_fingertree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_fundeque_fingertree 10
cleanall:: ; $(RMF) libats_fundeque_fingertree

######

checkall:: libats_funheap_braun
libats_funheap_braun: libats_funheap_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funheap_braun

######

checkall:: libats_funmap_avltree
libats_funmap_avltree: libats_funmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funmap_avltree

checkall:: libats_funset_avltree
libats_funset_avltree: libats_funset_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funset_avltree

######

checkall:: libats_funset_listord
libats_funset_listord: libats_funset_listord.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 1000
cleanall:: ; $(RMF) libats_funset_listord

######

checkall:: libats_funralist_nested
libats_funralist_nested: libats_funralist_nested.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funralist_nested

######

checkall:: libats_genarrays
libats_genarrays: libats_genarrays.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_genarrays
cleanall:: ; $(RMF) libats_genarrays

######

checkall:: libats_hashtable_chain
libats_hashtable_chain: libats_hashtable_chain.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_chain 100000
cleanall:: ; $(RMF) libats_hashtable_chain

checkall:: libats_hashtable_linprb
libats_hashtable_linprb: libats_hashtable_linprb.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_linprb 100000
cleanall:: ; $(RMF) libats_hashtable_linprb

######

checkall:: libats_intinf
libats_intinf: libats_intinf.dats
	$(ATSCC) -O2 -o $@ $< -lats -lgmp && ./libats_intinf 10
cleanall:: ; $(RMF) libats_intinf

checkall:: libats_iterint
libats_iterint: libats_iterint.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_iterint
cleanall:: ; $(RMF) libats_iterint

######

checkall:: libats_linbitvec
libats_linbitvec: libats_linbitvec.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_linbitvec
cleanall:: ; $(RMF) libats_linbitvec

######

checkall:: libats_linmap_avltree
libats_linmap_avltree: libats_linmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linmap_avltree 100000
cleanall:: ; $(RMF) libats_linmap_avltree

######

checkall:: libats_linqueue_arr
libats_linqueue_arr: libats_linqueue_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_arr 1000000
cleanall:: ; $(RMF) libats_linqueue_arr

######

checkall:: libats_linqueue_lst
libats_linqueue_lst: libats_linqueue_lst.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_lst 1000000
cleanall:: ; $(RMF) libats_linqueue_lst

######

checkall:: libats_linstack_arr
libats_linstack_arr: libats_linstack_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linstack_arr 1000000
cleanall:: ; $(RMF) libats_linstack_arr

######

checkall:: libats_parworkshop
libats_parworkshop: libats_parworkshop.dats
	$(ATSCC) -D_ATS_MULTITHREAD -O2 -o $@ $< -lpthread -lats_mt && ./libats_parworkshop
cleanall:: ; $(RMF) libats_parworkshop

######

checkall:: libats_rarray
libats_rarray: libats_rarray.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_rarray
cleanall:: ; $(RMF) libats_rarray

######

checkall:: libats_regexp
libats_regexp: libats_regexp.dats
	$(ATSCC) -O2 -o $@ $< -lats -lpcre && ./libats_regexp
cleanall:: ; $(RMF) libats_regexp

######

checkall:: libats_vector
libats_vector: libats_vector.dats
	$(ATSCC) -O2 -o libats_vector libats_vector.dats && ./libats_vector
cleanall:: ; $(RMF) libats_vector

######

checkall:: libats_ngc_slist
libats_ngc_slist: libats_ngc_slist.dats
	$(ATSCC) -O2 -o $@ $< && ./$@
cleanall:: ; $(RMF) libats_ngc_slist

######

checkall:: libats_smlbas_array
libats_smlbas_array: libats_smlbas_array.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array

checkall:: libats_smlbas_array2
libats_smlbas_array2: libats_smlbas_array2.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array2

checkall:: libats_smlbas_char
libats_smlbas_char: libats_smlbas_char.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_char

checkall:: libats_smlbas_list
libats_smlbas_list: libats_smlbas_list.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_list

checkall:: libats_smlbas_string
libats_smlbas_string: libats_smlbas_string.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_string

checkall:: libats_smlbas_time
libats_smlbas_time: libats_smlbas_time.dats
	$(ATSCC) -O2 -o $@ $< -lm -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_time

######

RMF=rm -f

######

clean:
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== doc/TUTORIAL/contents/Makefile ===
######

DIR="."
OUTPUT="./OUTPUT"
FPROC="scripts/fproc"

######

HTMLFILES=\
  syntax-coloring.html \
  basics.html \
  filename-extensions.html \
  file-inclusion.html \
  compilation.html \
  ats-main.html \
  fixity.html \
  overloading.html \
  macros.html \
  function-or-closure.html \
  variadicity.html \
  tail-recursive-functions.html \
  termination-metrics.html \
  types-with-effects.html \
  templates.html \
  lists.html \
  val-and-var.html \
  call-by-reference.html \
  pointers.html \
  references.html \
  arrays-and-matrices.html \
  linear-arrays.html \
  strings.html \
  datatypes.html \
  dataprops.html \
  dataviews.html \
  dataviewtypes.html \
  pattern-matching.html \
  exceptions.html \
  higher-order-functions.html \
  lazy-evaluation.html \
  llazy-evaluation.html \
  input-and-output.html \
  ATS-and-C.html \
  programming-with-theorem-proving.html \
  casting-functions.html \
  stack-allocation.html \
  statetypes.html \
  loopcon.html \

######

tutorial_all: $(HTMLFILES)
	$(FPROC) -many $(HTMLFILES)
	scp $(OUTPUT)/tutorial_all.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

######

ones:: $(HTMLFILES)
	$(FPROC) -one syntax-coloring.html
	$(FPROC) -one basics.html
	$(FPROC) -one filename-extensions.html
	$(FPROC) -one file-inclusion.html
	$(FPROC) -one compilation.html
	$(FPROC) -one ats-main.html
	$(FPROC) -one fixity.html
	$(FPROC) -one overloading.html
	$(FPROC) -one macros.html
	$(FPROC) -one function-or-closure.html
	$(FPROC) -one variadicity.html
	$(FPROC) -one tail-recursive-functions.html
	$(FPROC) -one termination-metrics.html
	$(FPROC) -one types-with-effects.html
	$(FPROC) -one templates.html
	$(FPROC) -one lists.html
	$(FPROC) -one val-and-var.html
	$(FPROC) -one call-by-reference.html
	$(FPROC) -one pointers.html
	$(FPROC) -one references.html
	$(FPROC) -one arrays-and-matrices.html
	$(FPROC) -one linear-arrays.html
	$(FPROC) -one strings.html
	$(FPROC) -one datatypes.html
	$(FPROC) -one dataprops.html
	$(FPROC) -one dataviews.html
	$(FPROC) -one dataviewtypes.html
	$(FPROC) -one pattern-matching.html
	$(FPROC) -one exceptions.html
	$(FPROC) -one higher-order-functions.html
	$(FPROC) -one lazy-evaluation.html
	$(FPROC) -one llazy-evaluation.html
	$(FPROC) -one input-and-output.html
	$(FPROC) -one ATS-and-C.html
	$(FPROC) -one programming-with-theorem-proving.html
	$(FPROC) -one casting-functions.html
	$(FPROC) -one stack-allocation.html
	$(FPROC) -one statetypes.html
	$(FPROC) -one loopcon.html
	scp $(OUTPUT)/*.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

######

syntax-coloring::
	$(FPROC) -one syntax-coloring.html
	scp $(OUTPUT)/syntax-coloring.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

basics::
	$(FPROC) -one basics.html
	scp $(OUTPUT)/basics.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

filename-extensions::
	$(FPROC) -one filename-extensions.html
	scp $(OUTPUT)/filename-extensions.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

file-inclusion::
	$(FPROC) -one file-inclusion.html
	scp $(OUTPUT)/file-inclusion.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

compilation::
	$(FPROC) -one compilation.html
	scp $(OUTPUT)/compilation.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

ats-main::
	$(FPROC) -one ats-main.html
	scp $(OUTPUT)/ats-main.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

fixity::
	$(FPROC) -one fixity.html
	scp $(OUTPUT)/fixity.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

overloading::
	$(FPROC) -one overloading.html
	scp $(OUTPUT)/overloading.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

macros::
	$(FPROC) -one macros.html
	scp $(OUTPUT)/macros.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

function-or-closure:: function-or-closure.html
	$(FPROC) -one function-or-closure.html
	scp $(OUTPUT)/function-or-closure.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

variadicity::
	$(FPROC) -one variadicity.html
	scp $(OUTPUT)/variadicity.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

tail-recursive-functions::
	$(FPROC) -one tail-recursive-functions.html
	scp $(OUTPUT)/tail-recursive-functions.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

termination-metrics::
	$(FPROC) -one termination-metrics.html
	scp $(OUTPUT)/termination-metrics.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

types-with-effects::
	$(FPROC) -one types-with-effects.html
	scp $(OUTPUT)/types-with-effects.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

templates::
	$(FPROC) -one templates.html
	scp $(OUTPUT)/templates.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

lists::
	$(FPROC) -one lists.html
	scp $(OUTPUT)/lists.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

val-and-var::
	$(FPROC) -one val-and-var.html
	scp $(OUTPUT)/val-and-var.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

call-by-reference::
	$(FPROC) -one call-by-reference.html
	scp $(OUTPUT)/call-by-reference.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

pointers::
	$(FPROC) -one pointers.html
	scp $(OUTPUT)/pointers.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

references::
	$(FPROC) -one references.html
	scp $(OUTPUT)/references.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

arrays-and-matrices::
	$(FPROC) -one arrays-and-matrices.html
	scp $(OUTPUT)/arrays-and-matrices.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

linear-arrays::
	$(FPROC) -one linear-arrays.html
	scp $(OUTPUT)/linear-arrays.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

strings::
	$(FPROC) -one strings.html
	scp $(OUTPUT)/strings.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

datatypes:: datatypes.html
	$(FPROC) -one datatypes.html
	scp $(OUTPUT)/datatypes.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

dataprops:: dataprops.html
	$(FPROC) -one dataprops.html
	scp $(OUTPUT)/dataprops.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

dataviews::
	$(FPROC) -one dataviews.html
	scp $(OUTPUT)/dataviews.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

dataviewtypes::
	$(FPROC) -one dataviewtypes.html
	scp $(OUTPUT)/dataviewtypes.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

pattern-matching::
	$(FPROC) -one pattern-matching.html
	scp $(OUTPUT)/pattern-matching.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

exceptions::
	$(FPROC) -one exceptions.html
	scp $(OUTPUT)/exceptions.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

higher-order-functions::
	$(FPROC) -one higher-order-functions.html
	scp $(OUTPUT)/higher-order-functions.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

lazy-evaluation::
	$(FPROC) -one lazy-evaluation.html
	scp $(OUTPUT)/lazy-evaluation.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

llazy-evaluation::
	$(FPROC) -one llazy-evaluation.html
	scp $(OUTPUT)/llazy-evaluation.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

input-and-output::
	$(FPROC) -one input-and-output.html
	scp $(OUTPUT)/input-and-output.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

ATS-and-C::
	$(FPROC) -one ATS-and-C.html
	scp $(OUTPUT)/ATS-and-C.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

programming-with-theorem-proving::
	$(FPROC) -one programming-with-theorem-proving.html
	scp $(OUTPUT)/programming-with-theorem-proving.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

casting-functions::
	$(FPROC) -one casting-functions.html
	scp $(OUTPUT)/casting-functions.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

stack-allocation::
	$(FPROC) -one stack-allocation.html
	scp $(OUTPUT)/stack-allocation.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

statetypes::
	$(FPROC) -one statetypes.html
	scp $(OUTPUT)/statetypes.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

loopcon::
	$(FPROC) -one loopcon.html
	scp $(OUTPUT)/loopcon.html \
          ats-hwxi,ats-lang@web.sourceforge.net:htdocs/TUTORIAL/contents/

######

ATSHOMEQ="$(ATSHOME)"
ATSCC=$(ATSHOMEQ)/bin/atscc
ATSDOC=$(ATSHOMEQ)/bin/atsdoc

######

compall::
	$(ATSCC)  basics.dats -lm
	$(ATSCC)  ats-main.dats
	$(ATSCC)  tail-recursive-functions.dats
	$(ATSCC)  termination-metrics.dats
	$(ATSCC)  -tc templates.dats
	$(ATSCC)  -tc lists.dats
	$(ATSCC)  -tc val-and-var.dats
	$(ATSCC)  -tc pointers.dats
	$(ATSCC)  references.dats
	$(ATSCC)  arrays-and-matrices.dats
	$(ATSCC)  linear-arrays.dats
	$(ATSCC)  -tc strings.dats
	$(ATSCC)  -tc dataprops.dats
	$(ATSCC)  datatypes.dats
	$(ATSCC)  -tc dataviews.dats
	$(ATSCC)  -tc dataviewtypes.dats
	$(ATSCC)  variadicity.dats
	$(ATSCC)  -tc pattern-matching.dats
	$(ATSCC)  lazy-evaluation.dats
	$(ATSCC)  -tc llazy-evaluation.dats
	$(ATSCC)  input-and-output.dats
	$(ATSCC)  ATS-and-C.dats
	$(ATSCC)  programming-with-theorem-proving.dats
	$(ATSCC)  -tc casting-functions.dats
	$(ATSCC)  stack-allocation.dats
	$(ATSCC)  -tc loopcon.dats

######

function-or-closure_: function-or-closure_atxt.dats
	$(ATSCC) -D_ATS_GCATS -o $@ function-or-closure_atxt.dats -latsdoc
function-or-closure_atxt.dats: function-or-closure.atxt
	$(ATSDOC) -do $@ -i function-or-closure.atxt > function-or-closure_atxt.txt
function-or-closure.html: function-or-closure_ ; ./function-or-closure_ > $@

clean:: ; $(RMF) function-or-closure_
cleanall:: ; $(RMF) function-or-closure.html

######

datatypes_: datatypes_atxt.dats
	$(ATSCC) -D_ATS_GCATS -o $@ datatypes_atxt.dats -latsdoc
datatypes_atxt.dats: datatypes.atxt
	$(ATSDOC) -do $@ -i datatypes.atxt > datatypes_atxt.txt
datatypes.html: datatypes_ ; ./datatypes_ > $@

clean:: ; $(RMF) datatypes_
cleanall:: ; $(RMF) datatypes.html

######

dataprops_: dataprops_atxt.dats
	$(ATSCC) -D_ATS_GCATS -o $@ dataprops_atxt.dats -latsdoc
dataprops_atxt.dats: dataprops.atxt
	$(ATSDOC) -do $@ -i dataprops.atxt > dataprops_atxt.txt
dataprops.html: dataprops_ ; ./dataprops_ > $@

clean:: ; $(RMF) dataprops_
cleanall:: ; $(RMF) dataprops.html

######

RMF=rm -f

######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.c
clean:: ; $(RMF) *_?ats.o
clean:: ; $(RMF) *_atxt.dats

cleanall:: clean
cleanall:: ; $(RMF) *_?ats.html

###### end of [Makefile] ######

=== debian/changelog ===
ats-lang-anairiats (0.2.5-1) unstable; urgency=low

  * New upstream release (Closes: #645134)
  * Fixes build (Closes: #633300)

 -- Matthew Danish <mrd@debian.org>  Wed, 12 Oct 2011 18:17:09 -0400

=== debian/control ===
Source: ats-lang-anairiats
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
Standards-Version: 3.9.2
Homepage: http://www.ats-lang.org

Package: ats-lang-anairiats
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
Suggests: ats-lang-anairiats-examples, ats-lang-anairiats-doc
Description: ATS language compiler named Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler atsopt, the frontend atscc, and 
 the lexer atslex.

Package: ats-lang-anairiats-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Description: Examples for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some examples of the language.

Package: ats-lang-anairiats-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Section: doc
Description: Documentation for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some documentation for the language.
